/*
 * SampleLTVPDFTimeStampValidator.java
 *
 * Copyright(C) 2012-2022 AMANO Corporation. All Rights Reserved.
 *
 * PDF Lib-J API - TvvO
 *
 * w肳ꂽ^CX^vt PDF ؂
 * R\[vOłB
 *
 * ZLeB̏̕ꍇ
 * Usage: java SampleLTVPDFTimeStampValidator (TALL) FilePath CAFilePath CertificateFilePath
 *
 *    PDFFilePath          - PDF t@CpX
 *    CAFilePath           - CAؖt@CpX
 *    CertificateFilePath  - [gؖt@CpX
 *
 * PDF WZLeBL̏̕ꍇ
 * Usage: java SampleLTVPDFTimeStampValidator (TALL) FilePath UserPassword OwnerPassword CAFilePath CertificateFileaPath
 *
 *    PDFFilePath          - PDF t@CpX
 *    UserPassword         - [U[pX[h
 *    OwnerPassword        - I[i[pX[h
 *    CAFilePath           - CAؖt@CpX
 *    CertificateFilePath  - [gؖt@CpX
 *
 * TALLw肵ꍇAA}m^CX^vT[rX 3161 ɂĔsꂽ^CX^vyуA}m^CX^vT[rX 3161 ȊO
 * sꂽ^CX^vg[N̂Ačؖ܂܂Ȃ ^CX^v؂܂B
 */

import java.io.*;
import java.util.*;
import java.security.cert.*;

import jp.co.amano.etiming.apl3161.*;
import jp.co.amano.etiming.atss3161.*;

public class SampleLTVPDFTimeStampValidator {

	public static void main(String[] args) throws Exception {

		String pdfFilePath = null;

		String[] certFilePath = new String[2];
		certFilePath[0] = null;
		certFilePath[1] = null;
		
		char[] userPassword = null;
		char[] ownerPassword = null;
		
		int verifyTarget = LTVPDFTimeStampValidator.VERIFY_TARGET_AMANO;
		if (args.length == 2) {
			if (args[0].equals("TALL")) {
				showUsage();
			}
		}
		else if (args.length > 2) {
			if (args[0].equals("TALL")) {
				verifyTarget = LTVPDFTimeStampValidator.VERIFY_TARGET_FULL;
			}
		}

		if (verifyTarget == LTVPDFTimeStampValidator.VERIFY_TARGET_AMANO) {
			// `FbN
			if (args.length == 2 || args.length == 3) {
				pdfFilePath  = args[0];
				certFilePath[0] = args[1];
				if (args.length == 3) {
					certFilePath[1] = args[2];
				}
			} else if (args.length == 4 || args.length == 5) {
				pdfFilePath  = args[0];
				userPassword = args[1].toCharArray();
				ownerPassword = args[2].toCharArray();
				certFilePath[0] = args[3];
				if (args.length == 5) {
					certFilePath[1] = args[4];
				}
			} else {
				showUsage();
			}
		}
		else {
			// `FbN
			if (args.length == 3 || args.length == 4) {
				pdfFilePath  = args[1];
				certFilePath[0] = args[2];
				if (args.length == 4) {
					certFilePath[1] = args[3];
				}
			} else if (args.length == 5 || args.length == 6) {
				pdfFilePath  = args[1];
				userPassword = args[2].toCharArray();
				ownerPassword = args[3].toCharArray();
				certFilePath[0] = args[4];
				if (args.length == 6) {
					certFilePath[1] = args[5];
				}
			} else {
				showUsage();
			}
		}

		try {
			// PDF t@C̃I[v
			RandomAccessFile pdfDocument = new RandomAccessFile(pdfFilePath, "r");

			// PDF t@C؃IuWFNg𐶐
			AmanoTSTValidator amanoValidator = makeAmanoTSTValidator(certFilePath);
			LTVPDFTimeStampValidator pdfValidator = new LTVPDFTimeStampValidator(amanoValidator);
			
			// ^CX^v̌ؑΏۂݒ肷
			pdfValidator.setVerifyTarget(verifyTarget);

			// ؂
			Collection result = null;
			if (userPassword == null && ownerPassword == null) {
				result = pdfValidator.validate(pdfDocument);
			} else {
				result = pdfValidator.validate(pdfDocument, userPassword, ownerPassword);
			}
			
			ArrayList validatorList = new ArrayList();
			validatorList.addAll(result);
			
			for (int i = 0; i < validatorList.size(); i++) {
				if (validatorList.get(i) != null) {
					ValidationResultAndPDFTimeStamp resultAndPDFTimeStamp = (ValidationResultAndPDFTimeStamp)validatorList.get(i);
					TimeStampValidationException validationException = resultAndPDFTimeStamp.getValidatorResult();
					System.out.println("^CX^v" + (i + 1) + "F" + validationException.toString());
				}	
				else {
					System.out.println("^CX^v" + (i + 1) + "F؏܂B");
				}
			}
			
			if (validatorList != null) {
				validatorList.clear();
				validatorList = null;
			}
			
			pdfDocument.close();

		} catch (Exception ex) {
			ex.printStackTrace();
			System.out.println("؏s܂B");
		}
	}


	// ^CX^vg[N؃IuWFNg𐶐
	//     CRL 擾ꍇɎgp
	private static AmanoTSTValidator makeAmanoTSTValidator(String[] certPath) throws Exception {

		// CRL 擾ɎgpvLV̐ݒ
		ProxyHost proxy = null;

		// CRL pP[^[쐬
		CRLDistributionPointsCRLLocator crlLocator = new CRLDistributionPointsCRLLocator();
		crlLocator.setConnectionTimeout(15000);
		crlLocator.setTimeout(15000);
		crlLocator.setProxyHost(proxy);
		crlLocator.setUpdateInterval(60);

		// ؖpP[^[쐬
		CollectionCertificateLocator certLocator = makeCollectionCertificateLocator(certPath);

		// ^CX^vg[N؂IuWFNg𐶐
		return new AmanoTSTValidator(certLocator, crlLocator);
	}

	// ؖpP[^[IuWFNg𐶐
	private static CollectionCertificateLocator makeCollectionCertificateLocator(String[] certPath) throws Exception {

		// ؖt@Ng̍쐬
		CertificateFactory factory = CertificateFactory.getInstance("X.509");

		// ؖt@CǂݍŃXgɒǉ
		ArrayList certList = new ArrayList();
		for (int i = 0; i < certPath.length; i++) {
			if (certPath[i] == null || certPath[i].isEmpty()) {
				continue;
			}
			
			X509Certificate cert = (X509Certificate)factory.generateCertificate(new FileInputStream(certPath[i]));
			certList.add((X509Certificate)cert);
		}

		// ؖpP[^[IuWFNg𐶐
		return new CollectionCertificateLocator(certList);
	}
	
	private static void showUsage() {
		System.out.println("usage : java SampleLTVPDFTimeStampValidator (TALL) <PDFFilePath> <CertificateFilePath>");
		System.out.println("      : java SampleLTVPDFTimeStampValidator (TALL) <PDFFilePath> <CAFilePath> <CertificateFilePath>");
		System.out.println("      : java SampleLTVPDFTimeStampValidator (TALL) <PDFFilePath> <UserPassword> <OwnerPassword> <CertificateFilePath>");
		System.out.println("      : java SampleLTVPDFTimeStampValidator (TALL) <PDFFilePath> <UserPassword> <OwnerPassword> <CAFilePath> <CertificateFilePath>");
		System.out.println();
		System.out.println("      PDFFilePath          - ؂ PDF t@CpX");
		System.out.println("      UserPassword         - [U[pX[h");
		System.out.println("      OwnerPassword        - I[i[pX[h");
		System.out.println("      CAFilePath           - CAؖt@CpX");
		System.out.println("      CertificateFilePath  - [gؖt@CpX");
		System.exit(1);
	}
}
