/*
 * SamplePDFAttachFilesCreator.java
 *
 * Copyright(C) 2023 AMANO Corporation. All Rights Reserved.
 *
 * PDF Lib-J API - TvvO
 *
 * w肳ꂽ PDF t@Cɑ΂ăt@CYtR\[vOłB
 *
 * Usage: java SamplePDFAttachFilesCreator InputPDFFilePath AttachFilePath OutputPDFFilePath
 *
 *    InputPDFFilePath    - t@CYtp PDF t@CpX
 *    AttachFilePath      - Ytt@CpX
 *    OutputPDFFilePath   - t@CYtĂ PDF t@C̏o̓pX
 */

import java.io.*;
import java.util.*;

import jp.co.amano.etiming.apl3161.*;

public class SamplePDFAttachFilesCreator {

	public static void main(String[] args) throws Exception {

		String pdfFilePath = null;
		String attachFilePath  = null;
		String outputPDFFilePath = null;

		// `FbN
		if (args.length == 3) {
			pdfFilePath = args[0];
			attachFilePath = args[1];
			outputPDFFilePath = args[2];
		} else {
			System.out.println("usage : java SamplePDFAttachFilesCreator <InputPDFFilePath> <AttachFilePath> <OutputPDFFilePath>");
			System.out.println();
			System.out.println("      InputPDFFilePath   - t@CYtp PDF t@CpX");
			System.out.println("      AttachFilePath     - Ytt@CpX");
			System.out.println("      OutputPDFFilePath  - t@CYtĂ PDF t@C̏o̓pX");
			System.exit(1);
		}

		try {
			ArrayList filePathList = new ArrayList();
			filePathList.add(attachFilePath);
			
			PDFAttachFilesGenerator generator = new PDFAttachFilesGenerator(filePathList);

			// PDF t@C̃I[v
			RandomAccessFile pdfDocument = new RandomAccessFile(pdfFilePath, "r");

			// t@CYt
			InputStream attached = null;
			attached = generator.generate(pdfDocument);
			pdfDocument.close();

			// t@CYtĂ PDF t@C̕ۑ
			writeFile(attached, outputPDFFilePath);

			// Ytς݃f[^̓Xg[
			attached.close();

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	static void writeFile(InputStream in, String filePath) throws Exception {
		FileOutputStream out = new FileOutputStream(filePath);
		try {
			byte[] buf = new byte[4096];
			while (true) {
				int i = in.read(buf);
				if (i <= 0) {
					break;
				}
				out.write(buf, 0, i);
			}
		} finally {
			out.close();
		}
	}
}
